/**
 * jdasm.h -- Deassembler header file.
 *
 * Author: Gaurav Vaish <gvaish@iitk.ac.in>
 *         Gopal V (gopalv82@yahoo.com)
 *
 * (C) Gaurav Vaish, Gopal V; 2002
 */

#ifndef __JDASM_H
#define __JDASM_H

#include <jparser.h>

#define PRINT_OP_NAME(x)  printf("\t %s ", (x).mnemonic)

/**
 * Methods to help printing the deassmbled code.
 */

void print_interfaces(JVClass *klass, JVCPEntry *cp_entry);
void print_fields(JVClass *klass, JVCPEntry *cp_entry);
void print_string_cp(JVCPEntry *cp_entry, int i);
void print_byte_code(byte *code, int *start_index, int code_len, JVCPEntry *cp_entry);
void print_method_code(JVMethodEntry *method, JVCPEntry *cp_entry);
void print_methods(JVClass *klass, JVCPEntry *cp_entry);
void print_class(JVClass *klass, JVCPEntry *cp_entry);

void usage(void);

#endif __JDASM_H
