/**
 * jopcodes.h -- Java opcodes. See jopcodes.c for implementation
 *
 * Author: Gaurav Vaish <gvaish@iitk.ac.in>
 *         Gopal V (gopalv82@yahoo.com)
 *
 * (C) Gaurav Vaish, Gopal V; 2002
 *
 */

#ifndef __JOPCODES_H
#define __JOPCODES_H

/* Parameters passed to the opcode*/

/* Count */

#define NONE 0
#define I    1
#define II   2

/* Construct */

#define ARRAYTYPE    3
#define BIGCONSTANT  4
#define CONSTANT     5
#define CLASS        6
#define FIELD        7
#define IGNORE       8
#define INTERFACE    9
#define LABEL       10
#define METHOD      11
#define MARRAY      12
#define SWITCH      13

typedef struct
{
	unsigned char  opcode;
	char          *mnemonic;
	int            args;
} jopcode_map;

int search_jopcode_map(unsigned char jopcode);
jopcode_map get_jopcode_map(int index);

#endif